hdu 1885 Key Task(bfs+状态压缩)

Problem Description

The Czech Technical University is rather old — you already know that it celebrates 300 years of its existence in 2007. Some of the university buildings are old as well. And the navigation in old buildings can sometimes be a little bit tricky, because of strange long corridors that fork and join at absolutely unexpected places. 

The result is that some first-graders have often di?culties finding the right way to their classes. Therefore, the Student Union has developed a computer game to help the students to practice their orientation skills. The goal of the game is to find the way out of a labyrinth. Your task is to write a verification software that solves this game. 

The labyrinth is a 2-dimensional grid of squares, each square is either free or filled with a wall. Some of the free squares may contain doors or keys. There are four di?erent types of keys and doors: blue, yellow, red, and green. Each key can open only doors of the same color. 

You can move between adjacent free squares vertically or horizontally, diagonal movement is not allowed. You may not go across walls and you cannot leave the labyrinth area. If a square contains a door, you may go there only if you have stepped on a square with an appropriate key before.

Input

The input consists of several maps. Each map begins with a line containing two integer numbers R and C (1 ≤ R, C ≤ 100) specifying the map size. Then there are R lines each containing C characters. Each character is one of the following: 

Note that it is allowed to have
more than one exit,

no exit at all,

more doors and/or keys of the same color, and

keys without corresponding doors and vice versa.

You may assume that the marker of your position (“*”) will appear exactly once in every map. 

There is one blank line after each map. The input is terminated by two zeros in place of the map size.

Output

For each map, print one line containing the sentence “Escape possible in S steps.”, where S is the smallest possible number of step to reach any of the exits. If no exit can be reached, output the string “The poor student is trapped!” instead. 

One step is defined as a movement between two adjacent cells. Grabbing a key or unlocking a door does not count as a step.

Sample Input

1 10
*........X

1 3
*#X

3 20
####################
#XY.gBr.*.Rb.G.GG.y#
####################

0 0

Sample Output

Escape possible in 9 steps.
The poor student is trapped!
Escape possible in 45 steps.

Source

2008 “Shun Yu Cup” Zhejiang Collegiate Programming Contest - Warm Up(2)

我的标准写法:

 1 #include<iostream>
 2 #include<cstdio>
 3 #include<cstring>
 4 #include<cmath>
 5 #include<queue>
 6 using namespace std;
 7 #define MAXN 110
 8 struct Node{
 9     int x,y,step;
10     int key;
11 };
12 char map[MAXN][MAXN];
13 bool mark[MAXN][MAXN][22];
14 int dir[4][2]={{-1,0},{1,0},{0,-1},{0,1}};
15 int n,m;
16 Node st;
17 char Door[4]={‘B‘,‘Y‘,‘R‘,‘G‘};
18 char Key[4]={‘b‘,‘y‘,‘r‘,‘g‘};
19
20 void bfs(){
21     memset(mark,false,sizeof(mark));
22     queue<Node>Q;
23     Node p,q;
24     st.key=st.step=0;
25     mark[st.x][st.y][st.key]=true;
26     Q.push(st);
27     while(!Q.empty()){
28         p=Q.front();
29         Q.pop();
30         if(map[p.x][p.y]==‘X‘){
31             printf("Escape possible in %d steps.\n",p.step);
32             return ;
33         }
34         for(int i=0;i<4;i++){
35             q.x=p.x+dir[i][0];
36             q.y=p.y+dir[i][1];
37             q.step=p.step+1;
38             q.key=p.key;
39             if(mark[q.x][q.y][q.key]) continue;
40             if(q.x<1||q.x>n||q.y<1||q.y>m||map[q.x][q.y]==‘#‘)
41                 continue;
42             if(isupper(map[q.x][q.y])&&map[q.x][q.y]!=‘X‘){
43                 for(int j=0;j<4;j++){
44                     if(map[q.x][q.y]==Door[j]){
45                         if(q.key&(1<<j)){
46
47                                 mark[q.x][q.y][q.key]=true;
48                                 Q.push(q);
49                         }
50                     }
51                 }
52             }else if(islower(map[q.x][q.y])){
53                 for(int j=0;j<4;j++){
54                     if(map[q.x][q.y]==Key[j]){
55                         if((q.key&(1<<j))==0){
56                             q.key+=(1<<j);
57                             mark[q.x][q.y][q.key]=true;
58                             Q.push(q);
59                         }
60                     else{
61                            if(mark[q.x][q.y][q.key]==0){
62                                 mark[q.x][q.y][q.key]=true;
63                                Q.push(q);
64                               }
65                         }
66                     }
67                 }
68             }else {
69                     mark[q.x][q.y][q.key]=true;
70                     Q.push(q);
71             }
72         }
73     }
74     puts("The poor student is trapped!");
75 }
76
77
78 int main(){
79     while(scanf("%d%d",&n,&m),(n+m)){
80         for(int i=1;i<=n;i++){
81             scanf("%s",map[i]+1);
82             for(int j=1;j<=m;j++){
83                 if(map[i][j]==‘*‘)st.x=i,st.y=j;
84             }
85         }
86         bfs();
87     }
88     return 0;
89 }

时间: 2024-08-19 15:40:43

hdu 1885 Key Task(bfs+状态压缩)的相关文章

HDU1885 Key Task(BFS+状态压缩)

与HDU1429大致一样. 代码: #include<iostream> #include<cstdio> #include<cstring> #include<algorithm> #include<queue> using namespace std; const int MAX=100+10; struct point { int x,y,step,state; point(int x=0,int y=0,int step=0,int st

HDU 1885 Key Task 状态压缩+搜索

点击打开链接 Key Task Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1176    Accepted Submission(s): 462 Problem Description The Czech Technical University is rather old - you already know that it c

hdu 1885 Key Task (三维bfs)

题目 之前比赛的一个题, 当时是崔老师做的,今天我自己做了一下.... 还要注意用bfs的时候  有时候并不是最先到达的就是答案,比如HDU 3442 这道题是要求最小的消耗血量伤害,但是并不是最先到达目标点的路径 就是最小的伤害,因为每一个点的伤害是 不一样的, 这种情况要用优先队列优化, 对伤害优化. 题意:*开始, X出口, b, y, r, g 代表钥匙,分别可以开B, Y, R, G颜色的门, 钥匙可以多次使用.问最短的步骤. 思路:vis[][][]数组开三维,第三维记录状态 是否拿

HDU 1885 Key Task 国家压缩+搜索

点击打开链接 Key Task Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1176    Accepted Submission(s): 462 Problem Description The Czech Technical University is rather old - you already know that it c

HDU 1885Key Task(bfs + 状态压缩)

Key Task Time Limit: 3000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1529 Accepted Submission(s): 631 Problem Description The Czech Technical University is rather old - you already know that it celebrates 300

HDU 1885 Key Task

bfs. 一把某种颜色的锁开 所有这个颜色的门. 状态检查压缩一下  vis[][][2^4]; 跟HDU 1429 类似.至于颜色判断我用了 map: #include<cstdio> #include<cstring> #include<string> #include<queue> #include<algorithm> #include<map> #include<stack> #include<iostre

HDU 5094 --Maze【BFS &amp;&amp; 状态压缩】

Maze Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 100000/100000 K (Java/Others) Total Submission(s): 903    Accepted Submission(s): 316 Problem Description This story happened on the background of Star Trek. Spock, the deputy captain of St

hdu 5094 Maze (bfs+状态压缩)

Maze Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 100000/100000 K (Java/Others) Total Submission(s): 173    Accepted Submission(s): 71 Problem Description This story happened on the background of Star Trek. Spock, the deputy captain of Sta

hdoj 1885 Key Task 【BFS+状态压缩】

题目:hdoj 1885 Key Task 题意:给出一些点,然后有一些钥匙和门,钥匙拿到才可以打开门,问到出口的最短时间. 分析:很明显的广搜 + 状态压缩题目. 坑点: 1:题目没读清楚,以为要把所有的们打开才能出去. AC代码: #include <iostream> #include <stdio.h> #include <string.h> #include <algorithm> #include <queue> #include &